#include "smtp.h"
extern smtpi jtin;

// S:2005-08-29 gorila@dione.zcu.cz
int smtp_out_packets_S10N(smtpp par,char *lcType)
   {
   int liProcess=0,liCount=1;
   jpacket jp=par->jp;
   char *lcTo=NULL;
   smtp_jq loQueue;
   smtp_jq_x loData;

   // nkdo si pidal transport jako kontakt
   if (liProcess==0 && jp->subtype==JPACKET__SUBSCRIBED)
      {
      liProcess=-1;
      }

   // nkdo peruil pdan transportu jako kontakt
   if (liProcess==0 && jp->subtype==JPACKET__UNSUBSCRIBED)
      {
      liProcess=-1;
      }


   if (liProcess==0 && jp->subtype==JPACKET__SUBSCRIBE)
      {
      loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
      smtp_PoolsReg(1160, xmlnode_pool(loData->x));

log_notice("smtp","SUBSCRIBE %s",jp->to->user);

      xmlnode_put_attrib(loData->x,"type","subscribed");

      smtp_AppendQueueItem(loQueue, smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X));
      loData=(smtp_jq_x) loQueue->next->Data;
      loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
      smtp_PoolsReg(1170, xmlnode_pool(loData->x));

      xmlnode_insert_cdata(xmlnode_insert_tag(loData->x,"status"),"Online",-1);

      liProcess=1;
      if (j_strlen(jp->to->user)>0)
         {
         lcTo=xmlnode_get_attrib(jp->x,"to");

         liCount=smtp_online_add_item(smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")), lcTo);
         jtin->Stats->_CoreContactsOnline+=liCount;
         jtin->Stats->_CoreContacts+=liCount;
         smtp_StatsSave();
         }

      }




   if (liProcess==0 && jp->subtype==JPACKET__UNSUBSCRIBE)
      {
      loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
      loData=(smtp_jq_x) loQueue->Data;
      loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
      smtp_PoolsReg(1180, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","unsubscribed");

log_notice("smtp","UNSUBSCRIBE %s",jp->to->user);

      smtp_AppendQueueItem(loQueue, smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X));
      loData=(smtp_jq_x) loQueue->next->Data;
      loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
      smtp_PoolsReg(1190, xmlnode_pool(loData->x));

      xmlnode_put_attrib(loData->x,"type","unavailable");

      if (j_strlen(jp->to->user)>0)
         {
         lcTo=xmlnode_get_attrib(jp->x,"to");
         liCount=smtp_online_remove_item(smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")),lcTo);
         jtin->Stats->_CoreContactsOnline-=liCount;
         jtin->Stats->_CoreContacts-=liCount;
         smtp_StatsSave();
         }


      liProcess=1;
      }

   if (liProcess==1)
      smtp_FlushQueue(par->i, loQueue);


   return liProcess;
   }
// E:2005-08-29 gorila@dione.zcu.cz

