#include "smtp.h"
extern smtpi jtin;

// S:2005-08-29 gorila@dione.zcu.cz
int smtp_out_packets_presence(smtpp par,char *type)
   {
   int liProcess=0,liCount;
   jpacket jp=par->jp;
   smtp_jq loQueue;
   smtp_jq_x loData;

   switch(jp->subtype)
      {
      case JPACKET__AVAILABLE:
           loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
           loData=(smtp_jq_x) loQueue->Data;
           loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
           smtp_PoolsReg(1370, xmlnode_pool(loData->x));

      
           xmlnode_insert_cdata(xmlnode_insert_tag(loData->x,"status"),"Online",-1);
log_notice("smtp","available %s",jp->to->user);
// kdy porbhne poprv a empty(user) tak penastav online pro vechny a nstav pznak e probhl

           if (j_strlen(jp->to->user)==0)
              {
              liCount=smtp_online_add_item(smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")),NULL);
              jtin->Stats->_CoreContactsOnline+=liCount;
              smtp_StatsSave();
              }
 

		   liProcess=1;
           break;

      case JPACKET__UNAVAILABLE:
           loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
           loData=(smtp_jq_x) loQueue->Data;
           loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
           smtp_PoolsReg(1380, xmlnode_pool(loData->x));

           xmlnode_put_attrib(loData->x,"type","unavailable");
log_notice("smtp","unavailable %s",jp->to->user);
// kdy porbhne poprv a empty(user) tak penastav online pro vechny a nstav pznak e probhl

           if (j_strlen(jp->to->user)==0)
              {
              liCount=smtp_online_remove_item(smtp_GetJID(par->tmppool,xmlnode_get_attrib(jp->x,"from")),NULL);
              jtin->Stats->_CoreContactsOnline-=liCount;
              smtp_StatsSave();
              }


           liProcess=1;
           break;

      case JPACKET__PROBE:
           loQueue=smtp_NewQueueItem(par->tmppool,SMTP_QUEUE_X);
           loData=(smtp_jq_x) loQueue->Data;
           loData->x=out_SetReply(xmlnode_new_tag("presence"),jp->x);
           smtp_PoolsReg(1400, xmlnode_pool(loData->x));

           xmlnode_insert_cdata(xmlnode_insert_tag(loData->x,"status"),"Online",-1);

           liProcess=1;
           break;

      case JPACKET__ERROR:
           break;

      case JPACKET__INVISIBLE:
           break;
      }


   if (liProcess==1)
      smtp_FlushQueue(par->i, loQueue);


   return liProcess;
   }
// E:2005-08-29 gorila@dione.zcu.cz
